Index: gnome-panel-2.28.0/gnome-panel/panel-applet-frame.c
===================================================================
--- gnome-panel-2.28.0.orig/gnome-panel/panel-applet-frame.c
+++ gnome-panel-2.28.0/gnome-panel/panel-applet-frame.c
@@ -1035,6 +1035,26 @@ panel_applet_frame_loading_failed_respon
 	g_free (id);
 }
 
+static gboolean is_sles ()
+{
+	static const gchar *filename = "/etc/SuSE-brand";
+	GFile *file = NULL;
+	gboolean sles = FALSE;
+	gchar *contents = NULL;
+	
+	if (g_file_test (filename, G_FILE_TEST_EXISTS)) {
+		file = g_file_new_for_path (filename);
+		if (g_file_load_contents (file, NULL, &contents, NULL, NULL, NULL)) {
+			if (g_strrstr (contents, "SLES"))
+				sles = TRUE;
+			g_free (contents);
+		}
+		g_object_unref (file);
+	}
+	
+	return sles;
+}
+
 static void
 panel_applet_frame_loading_failed (PanelAppletFrame  *frame,
 				   const char        *id)
@@ -1048,47 +1068,50 @@ panel_applet_frame_loading_failed (Panel
 
 	locked_down = panel_lockdown_get_locked_down ();
 
-	problem_txt = g_strdup_printf (_("The panel encountered a problem "
-					 "while loading \"%s\"."),
-				       frame->priv->iid);
-
-	dialog = gtk_message_dialog_new (NULL, 0,
-					 locked_down ? GTK_MESSAGE_INFO : GTK_MESSAGE_WARNING,
-					 GTK_BUTTONS_NONE,
-					 "%s", problem_txt);
-	g_free (problem_txt);
-
-	if (locked_down) {
-		gtk_dialog_add_buttons (GTK_DIALOG (dialog),
-					GTK_STOCK_OK, LOADING_FAILED_RESPONSE_DONT_DELETE,
-					NULL);
-	} else {
-		gtk_message_dialog_format_secondary_text (GTK_MESSAGE_DIALOG (dialog),
-					_("Do you want to delete the applet "
-					  "from your configuration?"));
-		gtk_dialog_add_buttons (GTK_DIALOG (dialog),
-					PANEL_STOCK_DONT_DELETE, LOADING_FAILED_RESPONSE_DONT_DELETE,
-					GTK_STOCK_DELETE, LOADING_FAILED_RESPONSE_DELETE,
-					NULL);
+	/* bnc585737 - don't display warning caused by upgrade from sles10 */
+	if (strcmp (frame->priv->iid, "OAFIID:TomboyApplet") || !is_sles()) {
+		problem_txt = g_strdup_printf (_("The panel encountered a problem "
+						 "while loading \"%s\"."),
+						   frame->priv->iid);
+	
+		dialog = gtk_message_dialog_new (NULL, 0,
+						 locked_down ? GTK_MESSAGE_INFO : GTK_MESSAGE_WARNING,
+						 GTK_BUTTONS_NONE,
+						 "%s", problem_txt);
+		g_free (problem_txt);
+	
+		if (locked_down) {
+			gtk_dialog_add_buttons (GTK_DIALOG (dialog),
+						GTK_STOCK_OK, LOADING_FAILED_RESPONSE_DONT_DELETE,
+						NULL);
+		} else {
+			gtk_message_dialog_format_secondary_text (GTK_MESSAGE_DIALOG (dialog),
+						_("Do you want to delete the applet "
+						  "from your configuration?"));
+			gtk_dialog_add_buttons (GTK_DIALOG (dialog),
+						PANEL_STOCK_DONT_DELETE, LOADING_FAILED_RESPONSE_DONT_DELETE,
+						GTK_STOCK_DELETE, LOADING_FAILED_RESPONSE_DELETE,
+						NULL);
+		}
+	
+		gtk_dialog_set_default_response (GTK_DIALOG (dialog),
+						 LOADING_FAILED_RESPONSE_DONT_DELETE);
+	
+		gtk_window_set_screen (GTK_WINDOW (dialog),
+					   gtk_window_get_screen (GTK_WINDOW (frame->priv->panel->toplevel)));
+	
+		g_signal_connect (dialog, "response",
+				  G_CALLBACK (panel_applet_frame_loading_failed_response),
+				  g_strdup (id));
+	
+		panel_widget_register_open_dialog (frame->priv->panel, dialog);
+		gtk_window_set_urgency_hint (GTK_WINDOW (dialog), TRUE);
+		/* FIXME: http://bugzilla.gnome.org/show_bug.cgi?id=165132 */
+		gtk_window_set_title (GTK_WINDOW (dialog), _("Error"));
+	
+		gtk_widget_show_all (dialog);
 	}
 
-	gtk_dialog_set_default_response (GTK_DIALOG (dialog),
-					 LOADING_FAILED_RESPONSE_DONT_DELETE);
-
-	gtk_window_set_screen (GTK_WINDOW (dialog),
-			       gtk_window_get_screen (GTK_WINDOW (frame->priv->panel->toplevel)));
-
-	g_signal_connect (dialog, "response",
-			  G_CALLBACK (panel_applet_frame_loading_failed_response),
-			  g_strdup (id));
-
-	panel_widget_register_open_dialog (frame->priv->panel, dialog);
-	gtk_window_set_urgency_hint (GTK_WINDOW (dialog), TRUE);
-	/* FIXME: http://bugzilla.gnome.org/show_bug.cgi?id=165132 */
-	gtk_window_set_title (GTK_WINDOW (dialog), _("Error"));
-
-	gtk_widget_show_all (dialog);
-
 	g_free (frame->priv->iid);
 	frame->priv->iid = NULL;
 